/*
Copyright Renaud GICQUEL 2005-2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import com.sun.java.swing.*;
import java.beans.*;
import java.awt.*;
import java.util.*;
import rg.thopt.*;
import rg.corps.*;
import java.io.*;

/**
 * Classe pour calculer un cycle Diesel
 * 
 * le modle est celui de Thelliez
 *
 * Cette classe illustre la manire dont une classe externe peut piloter des reparamtrages 
 * varis d'un projet de structure donne
 *
 * @author Renaud GICQUEL
 */
public class PiloteDiesel extends ExtPilot implements Inversable
{
	boolean isInitialized=false;
	boolean isBuilt=false;
	String[]composant,nomComposant,nomNozz;
    String compressorName="",comb1Name="",comb2Name="",comb3Name="",expansionName="",nomPVE="";
    
    double  maxTemp, lossCoeff, N, comprRatio, RCA, Tcond, Sural, maxPress, Vs,massFlow,combFlow, 
    totalFlow, lambdaT, EGR, coolingFlow;	
    
    PointThopt amontCompr, avalCompr, avalComb1, avalComb2, avalComb3, avalDet, inAir, echap;
    PistonValveExhaust pve;
	String tab=new String("\t");
	String ligne=new String("\n");

	public PiloteDiesel()
	{
		//{{INIT_CONTROLS
		setTitle("Diesel pilot");
		getContentPane().setLayout(null);
		setSize(640,590);
		setVisible(false);
		JLabel6.setText("useful energy");
		getContentPane().add(JLabel6);
		JLabel6.setForeground(java.awt.Color.red);
		JLabel6.setBounds(12,312,156,24);
		getContentPane().add(Useful_value);
		Useful_value.setBounds(180,312,120,24);
		Useful_value.setSelectionColor(new java.awt.Color(204,204,255));
		Useful_value.setSelectedTextColor(java.awt.Color.black);
		Useful_value.setCaretColor(java.awt.Color.black);
		Useful_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel4.setText("efficiency");
		getContentPane().add(JLabel4);
		JLabel4.setForeground(java.awt.Color.red);
		JLabel4.setBounds(12,276,156,24);
		Efficiency_value.setSelectionColor(new java.awt.Color(204,204,255));
		Efficiency_value.setSelectedTextColor(java.awt.Color.black);
		Efficiency_value.setCaretColor(java.awt.Color.black);
		Efficiency_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Efficiency_value);
		Efficiency_value.setBounds(180,276,120,24);
		N_value.setText("1500");
		N_value.setSelectionColor(new java.awt.Color(204,204,255));
		N_value.setSelectedTextColor(java.awt.Color.black);
		N_value.setCaretColor(java.awt.Color.black);
		N_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(N_value);
		N_value.setBounds(480,120,100,24);
		JLabel5.setText("Rotation speed (rpm)");
		getContentPane().add(JLabel5);
		JLabel5.setForeground(new java.awt.Color(102,102,153));
		JLabel5.setBounds(312,120,156,24);
		bCalculate.setText("Calculate ");
		bCalculate.setActionCommand("Calculate ");
		getContentPane().add(bCalculate);
		bCalculate.setBounds(408,228,156,36);
		JLabel10.setText("Design settings");
		getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel10.setBounds(12,12,288,24);
		Vs_value.setText("40");
		Vs_value.setSelectionColor(new java.awt.Color(204,204,255));
		Vs_value.setSelectedTextColor(java.awt.Color.black);
		Vs_value.setCaretColor(java.awt.Color.black);
		Vs_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Vs_value);
		Vs_value.setBounds(480,84,100,24);
		JLabel12.setText("Capacity (l)");
		getContentPane().add(JLabel12);
		JLabel12.setBounds(312,84,156,24);
		JLabel13.setText("Thermal losses (%)");
		getContentPane().add(JLabel13);
		JLabel13.setForeground(new java.awt.Color(102,102,153));
		JLabel13.setBounds(12,156,161,22);
		loss_value.setText("19");
		getContentPane().add(loss_value);
		loss_value.setBounds(180,156,100,24);
		JLabel14.setText("Max pressure");
		getContentPane().add(JLabel14);
		JLabel14.setBounds(12,48,150,23);
		maxPress_value.setText("80");
		getContentPane().add(maxPress_value);
		maxPress_value.setBounds(180,48,100,24);
		JLabel16.setText("cooling energy");
		getContentPane().add(JLabel16);
		JLabel16.setForeground(java.awt.Color.red);
		JLabel16.setBounds(12,420,144,24);
		getContentPane().add(Cooling_value);
		Cooling_value.setBounds(180,420,120,24);
		JLabel15.setText("Suralimentation ratio");
		getContentPane().add(JLabel15);
		JLabel15.setBounds(312,156,156,24);
		Sural_value.setText("1");
		Sural_value.setSelectionColor(new java.awt.Color(204,204,255));
		Sural_value.setSelectedTextColor(java.awt.Color.black);
		Sural_value.setCaretColor(java.awt.Color.black);
		Sural_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Sural_value);
		Sural_value.setBounds(480,156,100,24);
		JLabel1.setText("Intake flow rate");
		getContentPane().add(JLabel1);
		JLabel1.setForeground(java.awt.Color.red);
		JLabel1.setBounds(324,276,156,24);
		massFlow_value.setSelectionColor(new java.awt.Color(204,204,255));
		massFlow_value.setSelectedTextColor(java.awt.Color.black);
		massFlow_value.setCaretColor(java.awt.Color.black);
		massFlow_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(massFlow_value);
		massFlow_value.setBounds(492,276,120,24);
		JLabel2.setText("Max temperature (C)");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(12,84,156,24);
		maxTemp_value.setText("1827");
		maxTemp_value.setSelectionColor(new java.awt.Color(204,204,255));
		maxTemp_value.setSelectedTextColor(java.awt.Color.black);
		maxTemp_value.setCaretColor(java.awt.Color.black);
		maxTemp_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(maxTemp_value);
		maxTemp_value.setBounds(180,84,100,24);
		JLabel3.setText("combustion flow");
		getContentPane().add(JLabel3);
		JLabel3.setForeground(java.awt.Color.red);
		JLabel3.setBounds(324,312,156,24);
		combFlow_value.setSelectionColor(new java.awt.Color(204,204,255));
		combFlow_value.setSelectedTextColor(java.awt.Color.black);
		combFlow_value.setCaretColor(java.awt.Color.black);
		combFlow_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(combFlow_value);
		combFlow_value.setBounds(492,312,120,24);
		comprRatio_value.setSelectionColor(new java.awt.Color(204,204,255));
		comprRatio_value.setSelectedTextColor(java.awt.Color.black);
		comprRatio_value.setCaretColor(java.awt.Color.black);
		comprRatio_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(comprRatio_value);
		comprRatio_value.setBounds(480,48,100,24);
		JLabel7.setText("purchased energy");
		getContentPane().add(JLabel7);
		JLabel7.setForeground(java.awt.Color.red);
		JLabel7.setBounds(12,384,156,24);
		Purchased_value.setSelectionColor(new java.awt.Color(204,204,255));
		Purchased_value.setSelectedTextColor(java.awt.Color.black);
		Purchased_value.setCaretColor(java.awt.Color.black);
		Purchased_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Purchased_value);
		Purchased_value.setBounds(180,384,120,24);
		JLabel8.setText("Simulation results");
		getContentPane().add(JLabel8);
		JLabel8.setForeground(java.awt.Color.red);
		JLabel8.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel8.setBounds(12,240,300,24);
		JLabel9.setText("Compression ratio");
		getContentPane().add(JLabel9);
		JLabel9.setBounds(312,48,156,24);
		comprRatio_value.setText("14");
		getContentPane().add(comprRatio_value);
		JLabel11.setText("Rapport air/comb");
		getContentPane().add(JLabel11);
		JLabel11.setForeground(java.awt.Color.red);
		JLabel11.setBounds(324,456,156,24);
		RCA_value.setSelectionColor(new java.awt.Color(204,204,255));
		RCA_value.setSelectedTextColor(java.awt.Color.black);
		RCA_value.setCaretColor(java.awt.Color.black);
		RCA_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(RCA_value);
		RCA_value.setBounds(492,456,120,24);
		JLabel17.setText("total flow");
		getContentPane().add(JLabel17);
		JLabel17.setForeground(java.awt.Color.red);
		JLabel17.setBounds(324,348,156,24);
		totalFlow_value.setSelectionColor(new java.awt.Color(204,204,255));
		totalFlow_value.setSelectedTextColor(java.awt.Color.black);
		totalFlow_value.setCaretColor(java.awt.Color.black);
		totalFlow_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(totalFlow_value);
		totalFlow_value.setBounds(492,348,120,24);
		JLabel18.setText("exhaust losses");
		getContentPane().add(JLabel18);
		JLabel18.setForeground(java.awt.Color.red);
		JLabel18.setBounds(324,384,156,24);
		exhaustLosses_value.setSelectionColor(new java.awt.Color(204,204,255));
		exhaustLosses_value.setSelectedTextColor(java.awt.Color.black);
		exhaustLosses_value.setCaretColor(java.awt.Color.black);
		exhaustLosses_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(exhaustLosses_value);
		exhaustLosses_value.setBounds(492,384,120,24);
		pumpingLosses_value.setSelectionColor(new java.awt.Color(204,204,255));
		pumpingLosses_value.setSelectedTextColor(java.awt.Color.black);
		pumpingLosses_value.setCaretColor(java.awt.Color.black);
		pumpingLosses_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(pumpingLosses_value);
		pumpingLosses_value.setBounds(492,420,120,24);
		JLabel19.setText("pumping losses");
		getContentPane().add(JLabel19);
		JLabel19.setForeground(java.awt.Color.red);
		JLabel19.setBounds(324,420,156,24);
		JLabel20.setText("lambda T Cste");
		getContentPane().add(JLabel20);
		JLabel20.setBounds(12,192,156,24);
		lambdaT_value.setText("14");
		lambdaT_value.setSelectionColor(new java.awt.Color(204,204,255));
		lambdaT_value.setSelectedTextColor(java.awt.Color.black);
		lambdaT_value.setCaretColor(java.awt.Color.black);
		lambdaT_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(lambdaT_value);
		lambdaT_value.setBounds(180,192,100,24);
		JLabel21.setText("exhaust temperature");
		getContentPane().add(JLabel21);
		JLabel21.setForeground(java.awt.Color.red);
		JLabel21.setBounds(12,456,144,24);
		getContentPane().add(Tex_value);
		Tex_value.setBounds(180,456,120,24);
		JLabel22.setText("EGR ratio (%)");
		getContentPane().add(JLabel22);
		JLabel22.setBounds(12,120,156,24);
		EGR_value.setText("10");
		EGR_value.setSelectionColor(new java.awt.Color(204,204,255));
		EGR_value.setSelectedTextColor(java.awt.Color.black);
		EGR_value.setCaretColor(java.awt.Color.black);
		EGR_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(EGR_value);
		EGR_value.setBounds(180,120,100,24);
		JLabel23.setText("torque");
		getContentPane().add(JLabel23);
		JLabel23.setForeground(java.awt.Color.red);
		JLabel23.setBounds(12,348,156,24);
		C_value.setSelectionColor(new java.awt.Color(204,204,255));
		C_value.setSelectedTextColor(java.awt.Color.black);
		C_value.setCaretColor(java.awt.Color.black);
		C_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(C_value);
		C_value.setBounds(180,348,120,24);
		JLabel24.setText("Cooling flow rate");
		getContentPane().add(JLabel24);
		JLabel24.setBounds(312,192,156,24);
		coolingFlow_value.setSelectionColor(new java.awt.Color(204,204,255));
		coolingFlow_value.setSelectedTextColor(java.awt.Color.black);
		coolingFlow_value.setCaretColor(java.awt.Color.black);
		coolingFlow_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(coolingFlow_value);
		coolingFlow_value.setBounds(480,192,100,24);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bCalculate.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		type="Pilote Diesel";
	}

    /**
    * returns the component type 
    **/
    public String getType(){
        return type;
    }
    
	public String getClassDescription(){
	    return "pilot for a diesel cycle\n\n\nauthor : R. Gicquel february 2008";
	}
    
	public void init(){
		isInitialized=true;
		proj=getProjet();
		//On rcupre la liste et le type des composants prsents dans l'diteur de schmas
		String[]listComp=proj.getEditorComponentList();
		composant=new String[listComp.length];
		nomComposant=new String[listComp.length];
		
		//on en extrait les noms des transfos du noyau dont on a besoin
        for(int i=0;i<listComp.length;i++){
		    composant[i]=Util.extr_value(listComp[i], "type");
		    nomComposant[i]=Util.extr_value(listComp[i], "name");
//		    if(composant[i].equals("Compression"))compressorName=nomComposant[i];
//		    if(composant[i].equals("Expansion"))compressorName=nomComposant[i];
            System.out.println(composant[i]+"\t"+nomComposant[i]);
            System.out.println(listComp[i]);
            System.out.println();
        }
        
        String[]listHX=proj.getHxList ();//ensuite, il faut utiliser getProperties
        for(int i=0;i<listHX.length;i++){
            System.out.println(listHX[i]);
            System.out.println();
        }
        
        Vector vExt=proj.getExternalClassInstances();//Vector contenant les classes externes
        int j=0;
        for(int i=0;i<vExt.size();i++){
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        ExtProcess ep=(ExtProcess)obj[1];
	        if(ep instanceof PistonValveExhaust){
	            pve=(PistonValveExhaust)ep;
	            nomPVE=pve.getName();
	            j++;
	        }
        }
        if(j!=1){
	        String msg = "Watch out: the Piston valve exhaust class is not loaded";
//	        JOptionPane.showMessageDialog(this, msg);  
        }
        //test de cohrence (des messages d'erreur plus prcis seraient souhaitables)
        if((!compressorName.equals(""))&& isBuilt)isBuilt=true;
		if(isBuilt)show();//on n'ouvre le pilote que si sa structure est correcte
		
        //initialisations pour la simulation         
        avalCompr=new PointThopt(proj,"2");
        amontCompr=new PointThopt(proj,"1");
        compressorName="compression";     
        comb1Name="combustion v = Cste";
        comb2Name="combustion p= Cste";
        comb3Name="combustion T = cste";
        expansionName="dtente";
        avalComb1=new PointThopt(proj,"3");
        avalComb2=new PointThopt(proj,"4");
        avalComb3=new PointThopt(proj,"5");
        avalDet=new PointThopt(proj,"6");
        inAir=new PointThopt(proj,"air ambiant");
        echap=new PointThopt(proj,"7");
	}
    
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == PiloteDiesel.this)
			Thrust_WindowClosing(event);
		}
	}

	void Thrust_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	com.sun.java.swing.JLabel JLabel6 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Useful_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel4 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Efficiency_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JTextField N_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel5 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JButton bCalculate = new com.sun.java.swing.JButton();
	com.sun.java.swing.JLabel JLabel10 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Vs_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel12 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JLabel JLabel13 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField loss_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel14 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField maxPress_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel16 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Cooling_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel15 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Sural_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel1 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField massFlow_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel2 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField maxTemp_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel3 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField combFlow_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel7 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Purchased_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel8 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JLabel JLabel9 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField comprRatio_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel11 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField RCA_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel17 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField totalFlow_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel18 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField exhaustLosses_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JTextField pumpingLosses_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel19 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JLabel JLabel20 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField lambdaT_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel21 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Tex_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel22 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField EGR_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel23 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField C_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel24 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField coolingFlow_value = new com.sun.java.swing.JTextField();
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bCalculate)
				bCalculate_actionPerformed(event);
		}
	}
	
	void bCalculate_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	    
	    lossCoeff=Util.lit_d(loss_value.getText());
	    maxPress=Util.lit_d(maxPress_value.getText());
	    maxTemp=Util.lit_d(maxTemp_value.getText())+273.15;
	    comprRatio=Util.lit_d(comprRatio_value.getText());
	    N=Util.lit_d(N_value.getText());
	    Vs=Util.lit_d(Vs_value.getText());
	    RCA=Util.lit_d(RCA_value.getText());
	    Sural=Util.lit_d(Sural_value.getText());
        lambdaT=Util.lit_d(lambdaT_value.getText());
        EGR=Util.lit_d(EGR_value.getText());
        coolingFlow=Util.lit_d(coolingFlow_value.getText());
	    
	    //prise en compte de la suralimentation (sans effet sur T pour le moment)
	    //il faudrait vrifier que amontCompr est bien en mode de calcul "systme ouvert"
	    // inclusion of supercharging (no effect on T for now)
        // we should check that amontCompr calculation mode is "open system"
	    amontCompr.P=inAir.P*0.95*Sural;
	    amontCompr.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
	    echap.P=(inAir.P+0.1)*Sural;
	    echap.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
        amontCompr.getProperties();
        double v1=amontCompr.V;
        
        double intermittenceFactor=0.5; //4 temps - 4 stroke
        double nc=4; //4 cylindres - 4 cylinders
        
        //dbits massiques - mass flow rates
        massFlow=N/60.*Vs/v1/1000.*nc;
        double fact=EGR/100;
        updateprocess("air ambiant", "Exchange",!RECALCULATE,!IS_SET_FLOW, UPDATE_FLOW, massFlow,  !UPDATE_ETA, 0);
        updateprocess("recirculation", "Exchange",!RECALCULATE,IS_SET_FLOW, UPDATE_FLOW, massFlow*fact,  !UPDATE_ETA, 0);
        updateNode("admission", RECALCULATE, !UPDATE_ETA, 0);
        amontCompr.getProperties();
        v1=amontCompr.V;
        updateprocess("entre refroidissement", "Exchange",!RECALCULATE,!IS_SET_FLOW, UPDATE_FLOW, coolingFlow,  !UPDATE_ETA, 0);
	    
	    //calcul du compresseur - compressor calculation
        updateprocess(compressorName, "Compression",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0,  !UPDATE_ETA, 0,  UPDATE_ETA, comprRatio);
        avalCompr.getProperties();
        
        //calcul de la premire combustion - first combustion calculation
        double lambda=Util.dicho_T (this,0,1, "calcComb1",1.4, 20,0.01);
        avalComb1.getProperties();
        
        //calcul de la deuxime combustion - second combustion calculation
        if(maxTemp<avalComb1.T){
            maxTemp=avalComb1.T+20;
            maxTemp_value.setText(Util.aff_d(maxTemp-273.15,5));
            updateprocess(comb2Name, "Combustion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0,  !UPDATE_ETA, 0,UPDATE_ETA, 100,UPDATE_ETA, 1-lossCoeff/100.);
        }
        else updateprocess(comb2Name, "Combustion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0,  UPDATE_ETA, maxTemp,!UPDATE_ETA, 0,UPDATE_ETA, 1-lossCoeff/100.);
	    
        //calcul de la troisime combustion - third combustion calculation
        updateprocess(comb3Name, "Combustion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0,  UPDATE_ETA, maxTemp,UPDATE_ETA, lambdaT, UPDATE_ETA, 1-lossCoeff/100.);
      
        //dtermination du dbit de carburant - fuel flow rate
        String[] args=new String[2];
        args[0]="process";
        args[1]="combustible";
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        double comb1Flow=f.doubleValue();
        combFlow=comb1Flow;
        args[1]="combustible 2";
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(3);
        double comb2Flow=f.doubleValue();
        combFlow=combFlow+comb2Flow;
        args[1]="combustible 3";
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(3);
        double comb3Flow=f.doubleValue();
        combFlow=combFlow+comb3Flow;
        
        RCA=massFlow/combFlow;
        RCA_value.setText(Util.aff_d(RCA,5));
        double coeff=(massFlow*(1.+fact)+combFlow)/massFlow/(1.+fact);
        totalFlow=massFlow*(1.+fact)+combFlow;
      
        avalComb2.getProperties();
        avalComb3.getProperties();
        double v6=v1/coeff;
        avalDet.P=v6;//on passe v dans P - v is transmitted throuph P in this method
        
        avalDet.update(!UPDATE_T,UPDATE_P,!UPDATE_X);//modifi pour qu'en systme ferm, ce soit V qui est mis  jour
        //il faudrait faire un test pour bien vrifier que avalDet est paramtr en systme ferm
         // changed so that in closed system, it is V which is updated
         // we should do a test to check that avalDet is set in a closed system
        updateprocess(expansionName, "Expansion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0,  !UPDATE_ETA, 0);
        avalDet.getProperties();
        updateprocess("chappement", "Expansion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0,  !UPDATE_ETA, 0);
        
        updateNode("chappement", RECALCULATE, !UPDATE_ETA, 0);
        updateHx("refroidissement 1", RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
        updateHx("refroidissement 2", RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
        updateHx("refroidissement 3", RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);

        echap.getProperties();
        
        //calcul du bilan
        args=new String[2];
        args[0]="process";
        args[1]=comb1Name;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(4);
        double deltaH1=f.doubleValue();
        
        args[1]=comb2Name;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(4);
        double deltaH2=f.doubleValue();
        f=(Double)vProp.elementAt(24);
        double tau2=f.doubleValue();
       
        args[1]=comb3Name;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(4);
        double deltaH3=f.doubleValue();
        f=(Double)vProp.elementAt(24);//travail utile pour transfos combustion
        double tau3=f.doubleValue();
        
        args[1]=expansionName;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(4);
        double tauExp=f.doubleValue();
        
        args[1]=compressorName;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(4);
        double tauCompr=f.doubleValue();
        
        args[1]="chappement";
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(4);        
        double exhaustLosses=-f.doubleValue();
        
        //pertes de pompage (cycle de balayage) -pumping losses (scavenging cycle)
        echap.getProperties();
        amontCompr.getProperties();
        avalCompr.getProperties();
        double pumpingLosses=-(amontCompr.P-echap.P)*(amontCompr.V-avalCompr.V)*100*massFlow;
 
        double payante=(deltaH1+deltaH2+deltaH3)*intermittenceFactor;
        double utile=(-tauCompr-tauExp-tau2-tau3-pumpingLosses)*intermittenceFactor;
        double eff=utile/payante;
        double cooling=(payante*lossCoeff/100.)*intermittenceFactor;
        pumpingLosses=pumpingLosses*intermittenceFactor;
        double torque=utile*30/Math.PI/N;
        combFlow=combFlow*intermittenceFactor;
        massFlow=massFlow;//*intermittenceFactor;
        
        Efficiency_value.setText(Util.aff_d(eff,5));
        C_value.setText(Util.aff_d(torque,5));
        Useful_value.setText(Util.aff_d(utile,5));
        Purchased_value.setText(Util.aff_d(payante,5));
        Cooling_value.setText(Util.aff_d(cooling,5));
        massFlow_value.setText(Util.aff_d(massFlow,5));
        combFlow_value.setText(Util.aff_d(combFlow,5));
        totalFlow_value.setText(Util.aff_d(totalFlow,5));
        exhaustLosses_value.setText(Util.aff_d(exhaustLosses,5));
        pumpingLosses_value.setText(Util.aff_d(pumpingLosses,5));    
        Tex_value.setText(Util.aff_d(echap.T-273.15,5));
        System.out.println("phase\tT \tP \tV");
        
        System.out.println("admission\t"+amontCompr.T+"\t"+amontCompr.P+"\t"+amontCompr.V);
        System.out.println("compression\t"+avalCompr.T+"\t"+avalCompr.P+"\t"+avalCompr.V);
        System.out.println("combustion v Cste\t"+avalComb1.T+"\t"+avalComb1.P+"\t"+avalComb1.V);
        System.out.println("combustion P Cste\t"+avalComb2.T+"\t"+avalComb2.P+"\t"+avalComb2.V);
        System.out.println("combustion T Cste\t"+avalComb3.T+"\t"+avalComb3.P+"\t"+avalComb3.V);
        System.out.println("dtente\t"+avalDet.T+"\t"+avalDet.P+"\t"+avalDet.V);
        System.out.println("chappement\t"+echap.T+"\t"+echap.P+"\t"+echap.V);
        System.out.println("flow\t"+massFlow+"\tcomb1Flow\t"+comb1Flow+"\tcomb2Flow\t"+comb2Flow+"\tcomb3Flow\t"+comb3Flow);
        System.out.println();
        System.out.println("flow\t"+massFlow+"\teff\t"+eff+"\tutile\t"+utile+"\tpayante\t"+payante);
        System.out.println("Tex\t"+Tex_value.getText()+"\tcombFlow\t"+combFlow+"\tmaxTemp\t"+maxTemp_value.getText()+"\tcooling\t"+cooling);
        
	}
	
	public double f_dicho(double X, double T,String fonc){
        
        if (fonc.equals("calcComb1"))return calcComb1(X);
        if (fonc.equals("calcComb3"))return calcComb3(X);
        return 0;
    }
    
    double calcComb1(double lambda){
        updateprocess(comb1Name, "Combustion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0,  !UPDATE_ETA, 0,  UPDATE_ETA, lambda, UPDATE_ETA, 1-lossCoeff/100.);
        avalComb1.getProperties();
        double res=avalComb1.P-maxPress;
        return res;
    }
    
    double calcComb3(double lambda){
        updateprocess(comb3Name, "Combustion",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0,  !UPDATE_ETA, 0,  UPDATE_ETA, lambda);
        String[] args=new String[2];
        args[0]="process";
        args[1]=comb3Name;
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        double flow=f.doubleValue();
        double res=flow-totalFlow;
        return res;
    }
    
	public void readCompParameters(String ligne_data){
	    
	    String value="";
	    value=Util.extr_value(ligne_data, "lossCoeff");
		if(!(value==null)){
		    lossCoeff=Util.lit_d(value);
	        loss_value.setText(Util.aff_d(lossCoeff,4));
	    }
	    value=Util.extr_value(ligne_data, "maxPress");
		if(!(value==null)){
		    maxPress=Util.lit_d(value);
	        maxPress_value.setText(Util.aff_d(maxPress,4));
	    }
	    value=Util.extr_value(ligne_data, "maxTemp");
		if(!(value==null)){
		    maxTemp=Util.lit_d(value);
	        maxTemp_value.setText(Util.aff_d(maxTemp-273.15,4));
	    }
	    value=Util.extr_value(ligne_data, "comprRatio");
		if(!(value==null)){
		    comprRatio=Util.lit_d(value);
	        comprRatio_value.setText(Util.aff_d(comprRatio,4));
	    }
	    value=Util.extr_value(ligne_data, "Vs");
		if(!(value==null)){
		    Vs=Util.lit_d(value);
	        Vs_value.setText(Util.aff_d(Vs,4));
	    }
	    value=Util.extr_value(ligne_data, "N");
		if(!(value==null)){
		    N=Util.lit_d(value);
	        N_value.setText(Util.aff_d(N,4));
	    }
	    value=Util.extr_value(ligne_data, "RCA");
		if(!(value==null)){
		    RCA=Util.lit_d(value);
	        RCA_value.setText(Util.aff_d(RCA,4));
	    }
	    value=Util.extr_value(ligne_data, "Sural");
		if(!(value==null)){
		    Sural=Util.lit_d(value);
	        Sural_value.setText(Util.aff_d(Sural,4));
	    }
	    value=Util.extr_value(ligne_data, "lambdaT");
		if(!(value==null)){
		    lambdaT=Util.lit_d(value);
	        lambdaT_value.setText(Util.aff_d(lambdaT,4));
	    }
	    value=Util.extr_value(ligne_data, "EGR");
		if(!(value==null)){
		    EGR=Util.lit_d(value);
	        EGR_value.setText(Util.aff_d(EGR,4));
	    }
	    value=Util.extr_value(ligne_data, "coolingFlow");
		if(!(value==null)){
		    coolingFlow=Util.lit_d(value);
	        coolingFlow_value.setText(Util.aff_d(coolingFlow,4));
	    }
	}
	
    public String saveCompParameters(){
	    String h="lossCoeff="+Util.aff_d(lossCoeff)+tab  
	    +"maxPress="+Util.aff_d(maxPress)+tab
	    +"maxTemp="+Util.aff_d(maxTemp)+tab
	    +"comprRatio="+Util.aff_d(comprRatio)+tab
	    +"Vs="+Util.aff_d(Vs)+tab
	    +"N="+Util.aff_d(N)+tab
	    +"RCA="+Util.aff_d(RCA)+tab
	    +"Sural="+Util.aff_d(Sural)+tab
	    +"lambdaT="+Util.aff_d(lambdaT)+tab
	    +"EGR="+Util.aff_d(EGR)+tab
	    +"Efficiency_value="+Efficiency_value.getText()+tab
	    +"Useful_value="+Useful_value.getText()+tab
	    +"Purchased_value="+Purchased_value.getText()+tab
	    +"Cooling_value="+Cooling_value.getText()+tab
	    +"exhaustLosses_value="+exhaustLosses_value.getText()+tab
	    +"pumpingLosses_value="+pumpingLosses_value.getText()+tab
	    +"coolingFlow="+coolingFlow_value.getText()+tab
	    
	    
	    ;
        return h;
    }
}